# ILLiad Caiasoft Remote Storage Integration Addon -- Decision Support

## Summary

This addon communicates with the Caiasoft API defined in the configuration to
initiate offsite requests through Caiasoft. Generates fulfillment options for
items that are available in Caiasoft and sends requests for those items if the
fulfillment option is selected.

## Installation

To install this Decision Support addon, create a new Decision Support addon via
ILLiad's Customization Manager by following the steps outlined in the
documentation.

The following settings must be set for each specific library:

* CaiasoftAPIUrl
* APIKey
* BarcodeMapping

There is also a custom queue that should be configured depending on the
configuration of the addon. With the default settings, you'll want to create a
custom queue named "Awaiting Offsite Delivery" in the Customization Manager.
 
## Settings

### CaiasoftAPIUrl

The Caiasoft API URL. Default value is "*https://yourlibrary.caiasoft.com/api/*"

### APIKey

The API Key for authenticating to the Caiasoft API.

### BarcodeMapping

The transaction field that contains the barcode of the material that should be
requested via Caiasoft. Default value is "*ItemNumber*"

### ValidItemAvailableStatuses

The item statuses that indicate that an item is available for requesting.
Multiple entries can be delimited by semicolons. Default value is
"*ValidItemAvailableStatuses*"

### ItemCost

Determines the Cost value for all of the fulfillment options that are generated
by this addon. Default is 0.

### ItemTurnaroundTime

Determines the Turnaround Time of all fulfillment options generated by this
addon. Default is 0.

### ProcessedStatus

The queue that the request will be moved to after the offsite retrieval request
has been submitted. Default value is "*Awaiting Offsite Delivery*"

### HistoryEntrySuccess

The history entry made when the request is processed by CaiaSoft. Leave blank
for no history entry. Default value is "*CaiaSoft: Request Posted. (Barcode:
{barcode})*"

## JSON Templates - Datamapping

The JSON templates used to create the request to the Caiasoft API can be
customized in the DataMapping.lua file. The mapping makes use of tag
replacements.

The TableField tag allows for replacing a value from another ILLiad table. The
addon can support retrieving values from the User, Transaction, or LocalInfo
tables. The tag syntax uses pipes to denote a tag and must start with
TableField: followed by the ILLiad table, then a period, and finally the field
name. Example: {TableField:User.FirstName}

#### Combining tags and static text

When the addon setting is evaluated tag replacement values are processed and all
other text stays as-is. As an example, to set the TransactionNumber value to
have a prefix of "ILLiad TN:", the setting value would be set to ILLiad
TN:{TableField:Transaction.TransactionNumber}. This would get evaluated as
"ILLiad TN:12345" if the addon was processing transaction 12345.
